/*
**
** This file is part of the BHack Beacon.
**
** Author(s):
**  - Ian Firns <firnsy@gmail.com>
**
** BHack Beacon is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation, either version 3 of the License, or
** (at your option) any later version.
**
** BHack Beacon is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with BHack Beacon.  If not, see <http://www.gnu.org/licenses/>.
**
*/

#define ANIMATIONS_MAX 13

const uint16_t *animationActive = NULL;
int16_t animationLoop = -1;
uint16_t animationLength = 0;
uint16_t animationIndex = 0;
uint32_t animationTimeRef = 0;

const uint16_t PROGMEM blueBreatherData[] = {
  0x0018,  // frame length = 24
  0x0000, 0x0000, 0x0000, 0x0000, 0x0021, 0x0021, 0x0021, 0x0021,
  0x0042, 0x0042, 0x0042, 0x0062, 0x00a4, 0x00a4, 0x00a5, 0x00a4,
  0x00e7, 0x00e7, 0x00e7, 0x00e7, 0x014a, 0x014a, 0x014a, 0x014a,
  0x01ce, 0x01ce, 0x01ce, 0x01ce, 0x0231, 0x0231, 0x0231, 0x0231,
  0x0294, 0x0294, 0x0294, 0x0294, 0x02d6, 0x02d6, 0x02d6, 0x02d6,
  0x0318, 0x0318, 0x0318, 0x0318, 0x0339, 0x0339, 0x0339, 0x0339,
  0x0339, 0x0339, 0x0339, 0x0339, 0x0318, 0x0318, 0x0318, 0x0318,
  0x02d6, 0x02d6, 0x02d6, 0x02d6, 0x0294, 0x0294, 0x0294, 0x0294,
  0x0231, 0x0231, 0x0231, 0x0231, 0x01ce, 0x01ce, 0x01ce, 0x01ce,
  0x014a, 0x014a, 0x014a, 0x014a, 0x00e7, 0x00e7, 0x00e7, 0x00e7,
  0x00a4, 0x00a4, 0x00a4, 0x00a4, 0x0062, 0x0042, 0x0042, 0x0062,
  0x0021, 0x0021, 0x0021, 0x0021, 0x0000, 0x0000, 0x0000, 0x0000
};
const uint16_t PROGMEM blueChaserData[] = {
  0x0018,  // frame length = 24
  0x01ac, 0x0339, 0x0129, 0x0000, 0x0230, 0x0318, 0x00c6, 0x0000,
  0x0293, 0x02d6, 0x0083, 0x0021, 0x02d6, 0x0294, 0x0021, 0x0063,
  0x0318, 0x0230, 0x0000, 0x00c6, 0x0339, 0x018c, 0x0000, 0x0129,
  0x0339, 0x0129, 0x0000, 0x018c, 0x0318, 0x00c6, 0x0000, 0x0230,
  0x02d6, 0x0083, 0x0021, 0x0293, 0x0293, 0x0021, 0x0083, 0x02d6,
  0x0230, 0x0000, 0x00c6, 0x0318, 0x01ac, 0x0000, 0x0129, 0x0339,
  0x0129, 0x0000, 0x01ac, 0x0339, 0x00c6, 0x0000, 0x0230, 0x0318,
  0x0083, 0x0021, 0x0294, 0x02d6, 0x0021, 0x0083, 0x02d6, 0x0293,
  0x0000, 0x00c6, 0x0318, 0x0230, 0x0000, 0x0129, 0x0339, 0x018c,
  0x0000, 0x018c, 0x0339, 0x0129, 0x0000, 0x0230, 0x0318, 0x00c6,
  0x0021, 0x0294, 0x02d6, 0x0063, 0x0083, 0x02d6, 0x0294, 0x0021,
  0x00c6, 0x0318, 0x0230, 0x0000, 0x0129, 0x0339, 0x01ac, 0x0000
};
const uint16_t PROGMEM greenBreatherData[] = {
  0x0018,  // frame length = 24
  0x0000, 0x0000, 0x0000, 0x0000, 0x0020, 0x0020, 0x0040, 0x0020,
  0x0080, 0x0080, 0x0080, 0x0080, 0x00e0, 0x00e0, 0x00e0, 0x00e0,
  0x0160, 0x0160, 0x0160, 0x0160, 0x01e0, 0x01e0, 0x01e0, 0x01e0,
  0x02a0, 0x02a0, 0x02a0, 0x02a0, 0x0340, 0x0340, 0x0340, 0x0340,
  0x03c0, 0x03c0, 0x03c0, 0x03c0, 0x0420, 0x0420, 0x0420, 0x0420,
  0x0480, 0x0480, 0x0480, 0x0480, 0x04a0, 0x04a0, 0x04a0, 0x04c0,
  0x04c0, 0x04a0, 0x04a0, 0x04a0, 0x0480, 0x0480, 0x0480, 0x0480,
  0x0420, 0x0420, 0x0420, 0x0420, 0x03c0, 0x03c0, 0x03c0, 0x03c0,
  0x0340, 0x0340, 0x0340, 0x0340, 0x02a0, 0x02a0, 0x02a0, 0x02a0,
  0x01e0, 0x01e0, 0x01e0, 0x01e0, 0x0160, 0x0160, 0x0160, 0x0160,
  0x00e0, 0x00e0, 0x00e0, 0x00e0, 0x0080, 0x0080, 0x0080, 0x0080,
  0x0020, 0x0040, 0x0020, 0x0040, 0x0000, 0x0000, 0x0000, 0x0000
};
const uint16_t PROGMEM greenChaserData[] = {
  0x0018,  // frame length = 24
  0x0260, 0x04a0, 0x01c0, 0x0000, 0x0320, 0x0480, 0x0120, 0x0000,
  0x03a0, 0x0420, 0x00a0, 0x0040, 0x0420, 0x03c0, 0x0040, 0x00a0,
  0x0480, 0x0320, 0x0000, 0x0120, 0x04c0, 0x0260, 0x0000, 0x01c0,
  0x04c0, 0x01c0, 0x0000, 0x0260, 0x0480, 0x0120, 0x0000, 0x0320,
  0x0420, 0x00a0, 0x0040, 0x03a0, 0x03a0, 0x0040, 0x00a0, 0x0420,
  0x0320, 0x0000, 0x0120, 0x0480, 0x0260, 0x0000, 0x01c0, 0x04a0,
  0x01c0, 0x0000, 0x0260, 0x04a0, 0x0120, 0x0000, 0x0320, 0x0480,
  0x00a0, 0x0040, 0x03c0, 0x0420, 0x0040, 0x00a0, 0x0420, 0x03a0,
  0x0000, 0x0120, 0x0480, 0x0320, 0x0000, 0x01c0, 0x04c0, 0x0260,
  0x0000, 0x0260, 0x04c0, 0x01c0, 0x0000, 0x0320, 0x0480, 0x0120,
  0x0040, 0x03c0, 0x0420, 0x00a0, 0x00a0, 0x0420, 0x03c0, 0x0040,
  0x0120, 0x0480, 0x0320, 0x0000, 0x01c0, 0x04a0, 0x0260, 0x0000
};
const uint16_t PROGMEM greyBreatherData[] = {
  0x0018,  // frame length = 24
  0x0000, 0x0000, 0x0000, 0x0000, 0x0020, 0x0020, 0x0020, 0x0020,
  0x1082, 0x1082, 0x0861, 0x0861, 0x18c3, 0x18c3, 0x18c3, 0x18c3,
  0x2945, 0x2945, 0x2945, 0x2945, 0x39c7, 0x39c7, 0x39c7, 0x39c7,
  0x4a69, 0x4a69, 0x4a69, 0x4a69, 0x630c, 0x5aeb, 0x630c, 0x630c,
  0x6b6d, 0x6b6d, 0x6b6d, 0x6b6d, 0x7bef, 0x7bef, 0x7bef, 0x7bcf,
  0x8430, 0x8430, 0x8430, 0x8430, 0x8c51, 0x8c51, 0x8c51, 0x8c71,
  0x8c71, 0x8c51, 0x8c51, 0x8c51, 0x8430, 0x8430, 0x8430, 0x8430,
  0x7bef, 0x7bef, 0x7bef, 0x7bef, 0x6b6d, 0x6b6d, 0x6b6d, 0x6b6d,
  0x630c, 0x630c, 0x630c, 0x630c, 0x4a69, 0x4a69, 0x4a69, 0x4a69,
  0x39c7, 0x39c7, 0x39c7, 0x39c7, 0x2945, 0x2945, 0x2945, 0x2945,
  0x18c3, 0x18c3, 0x18c3, 0x18c3, 0x1082, 0x0861, 0x0861, 0x1082,
  0x0020, 0x0020, 0x0020, 0x0020, 0x0000, 0x0000, 0x0000, 0x0000
};
const uint16_t PROGMEM greyChaserData[] = {
  0x0018,  // frame length = 24
  0x4228, 0x8c51, 0x31a6, 0x0000, 0x5aeb, 0x8430, 0x2104, 0x0000,
  0x6b6d, 0x7bef, 0x10a2, 0x0841, 0x7bcf, 0x6b6d, 0x0841, 0x10a2,
  0x8430, 0x5aeb, 0x0000, 0x2104, 0x8c71, 0x4228, 0x0000, 0x31a6,
  0x8c71, 0x3186, 0x0000, 0x4228, 0x8430, 0x2104, 0x0000, 0x5aeb,
  0x7bcf, 0x10a2, 0x0841, 0x6b6d, 0x6b6d, 0x0020, 0x10a2, 0x7bef,
  0x5aeb, 0x0000, 0x2104, 0x8430, 0x4228, 0x0000, 0x31a6, 0x8c51,
  0x31a6, 0x0000, 0x4228, 0x8c51, 0x2104, 0x0000, 0x5aeb, 0x8430,
  0x10a2, 0x0020, 0x6b6d, 0x7bef, 0x0020, 0x10a2, 0x7bef, 0x6b6d,
  0x0000, 0x2104, 0x8430, 0x5aeb, 0x0000, 0x3186, 0x8c71, 0x4228,
  0x0000, 0x4228, 0x8c71, 0x31a6, 0x0000, 0x5aeb, 0x8430, 0x2104,
  0x0020, 0x6b6d, 0x7bef, 0x10a2, 0x10a2, 0x7bef, 0x6b6d, 0x0841,
  0x2104, 0x8430, 0x5aeb, 0x0000, 0x31a6, 0x8c51, 0x4228, 0x0000
};
const uint16_t PROGMEM magentaBreatherData[] = {
  0x0018,  // frame length = 24
  0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0001, 0x0000,
  0x1002, 0x1002, 0x1002, 0x0802, 0x1803, 0x1803, 0x1803, 0x1803,
  0x2805, 0x2805, 0x2805, 0x2805, 0x3807, 0x3807, 0x3807, 0x3807,
  0x500a, 0x500a, 0x480a, 0x480a, 0x600d, 0x600d, 0x600d, 0x600d,
  0x680f, 0x700f, 0x700f, 0x700f, 0x7810, 0x7810, 0x7810, 0x7810,
  0x8012, 0x8812, 0x8812, 0x8812, 0x8812, 0x8812, 0x8812, 0x8813,
  0x8813, 0x8812, 0x8812, 0x8812, 0x8812, 0x8812, 0x8812, 0x8012,
  0x7810, 0x7810, 0x7810, 0x7810, 0x680f, 0x700f, 0x680f, 0x700f,
  0x600d, 0x600d, 0x600d, 0x600d, 0x500a, 0x480a, 0x500a, 0x480a,
  0x3807, 0x3807, 0x3807, 0x3807, 0x2805, 0x2805, 0x2805, 0x2805,
  0x1803, 0x1803, 0x1803, 0x1803, 0x1002, 0x1002, 0x1002, 0x1002,
  0x0000, 0x0001, 0x0000, 0x0001, 0x0000, 0x0000, 0x0000, 0x0000
};
const uint16_t PROGMEM magentaChaserData[] = {
  0x0018,  // frame length = 24
  0x4809, 0x8812, 0x3007, 0x0000, 0x580c, 0x8012, 0x2004, 0x0000,
  0x680e, 0x7810, 0x1002, 0x0801, 0x7810, 0x680f, 0x0801, 0x1002,
  0x8812, 0x580c, 0x0000, 0x2004, 0x8813, 0x4009, 0x0000, 0x3007,
  0x8813, 0x3007, 0x0000, 0x4809, 0x8812, 0x2004, 0x0000, 0x580c,
  0x7810, 0x1002, 0x0801, 0x680e, 0x680e, 0x0001, 0x1002, 0x7810,
  0x580c, 0x0000, 0x2004, 0x8012, 0x4809, 0x0000, 0x3007, 0x8812,
  0x3007, 0x0000, 0x4009, 0x8812, 0x2004, 0x0000, 0x580c, 0x8012,
  0x1002, 0x0001, 0x700f, 0x7810, 0x0001, 0x1002, 0x7810, 0x680e,
  0x0000, 0x2004, 0x8012, 0x580c, 0x0000, 0x3007, 0x8813, 0x4809,
  0x0000, 0x4009, 0x8813, 0x3007, 0x0000, 0x580c, 0x8012, 0x2004,
  0x0001, 0x680f, 0x7810, 0x1002, 0x1002, 0x7810, 0x700f, 0x0801,
  0x2004, 0x8012, 0x580c, 0x0000, 0x3007, 0x8812, 0x4009, 0x0000
};
const uint16_t PROGMEM redBreatherData[] = {
  0x0018,  // frame length = 24
  0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0800, 0x0000,
  0x1000, 0x1000, 0x1000, 0x1000, 0x1800, 0x1800, 0x1800, 0x1800,
  0x2800, 0x2800, 0x2800, 0x2800, 0x3800, 0x3800, 0x3800, 0x3800,
  0x5000, 0x5000, 0x5000, 0x5000, 0x6800, 0x6800, 0x6800, 0x6800,
  0x7800, 0x7800, 0x7800, 0x7800, 0x8000, 0x8000, 0x8000, 0x8000,
  0x9000, 0x9000, 0x9000, 0x9000, 0x9000, 0x9000, 0x9000, 0x9800,
  0x9800, 0x9000, 0x9000, 0x9000, 0x9000, 0x9000, 0x9000, 0x9000,
  0x8000, 0x8000, 0x8000, 0x8000, 0x7800, 0x7800, 0x7800, 0x7800,
  0x6800, 0x6800, 0x6800, 0x6800, 0x5000, 0x5000, 0x5000, 0x5000,
  0x3800, 0x3800, 0x3800, 0x3800, 0x2800, 0x2800, 0x2800, 0x2800,
  0x1800, 0x1800, 0x1800, 0x1800, 0x1000, 0x1000, 0x1000, 0x1000,
  0x0000, 0x0800, 0x0000, 0x0800, 0x0000, 0x0000, 0x0000, 0x0000
};
const uint16_t PROGMEM redChaserData[] = {
  0x0018,  // frame length = 24
  0x4800, 0x9000, 0x3800, 0x0000, 0x6000, 0x9000, 0x2000, 0x0000,
  0x7000, 0x8000, 0x1000, 0x0800, 0x8000, 0x7800, 0x0800, 0x1000,
  0x9000, 0x6000, 0x0000, 0x2000, 0x9800, 0x4800, 0x0000, 0x3800,
  0x9800, 0x3800, 0x0000, 0x4800, 0x9000, 0x2000, 0x0000, 0x6000,
  0x8000, 0x1000, 0x0800, 0x7000, 0x7000, 0x0800, 0x1000, 0x8000,
  0x6000, 0x0000, 0x2000, 0x9000, 0x4800, 0x0000, 0x3800, 0x9000,
  0x3800, 0x0000, 0x4800, 0x9000, 0x2000, 0x0000, 0x6000, 0x9000,
  0x1000, 0x0800, 0x7800, 0x8000, 0x0800, 0x1000, 0x8000, 0x7000,
  0x0000, 0x2000, 0x9000, 0x6000, 0x0000, 0x3800, 0x9800, 0x4800,
  0x0000, 0x4800, 0x9800, 0x3800, 0x0000, 0x6000, 0x9000, 0x2000,
  0x0800, 0x7800, 0x8000, 0x1000, 0x1000, 0x8000, 0x7800, 0x0800,
  0x2000, 0x9000, 0x6000, 0x0000, 0x3800, 0x9000, 0x4800, 0x0000
};
const uint16_t PROGMEM rgbyChaserData[] = {
  0x0010,  // frame length = 16
  0x0020, 0x0000, 0x0020, 0x0063, 0x0000, 0x0020, 0x0063, 0x00c6,
  0x0020, 0x0063, 0x00c6, 0x0129, 0x0063, 0x00c6, 0x0129, 0x01ad,
  0x00c6, 0x0129, 0x01ad, 0x020f, 0x0129, 0x01ad, 0x020f, 0x0231,
  0x01ad, 0x020f, 0x0231, 0x0231, 0x020f, 0x0231, 0x0231, 0x0210,
  0x0231, 0x0231, 0x0210, 0x01ce, 0x0231, 0x0210, 0x01ce, 0x018c,
  0x0210, 0x01ce, 0x018c, 0x0108, 0x01ef, 0x018c, 0x0108, 0x00a5,
  0x018c, 0x0108, 0x00a4, 0x0042, 0x0108, 0x00a5, 0x0042, 0x0000,
  0x00a5, 0x0042, 0x0000, 0x0000, 0x0042, 0x0000, 0x0000, 0x0021
};
const uint16_t PROGMEM xmasChaserData[] = {
  0x0040,  // frame length = 64
  0x05e0, 0x0000, 0x0000, 0x1000, 0x0540, 0x0000, 0x0000, 0x2800,
  0x0480, 0x0000, 0x0000, 0x4000, 0x03a0, 0x0000, 0x0000, 0x5800,
  0x02e0, 0x0000, 0x0000, 0x7000, 0x0200, 0x0000, 0x0000, 0x9000,
  0x0140, 0x0000, 0x0000, 0xa800, 0x0000, 0x0000, 0x0000, 0xb800,
  0x0000, 0x0000, 0x1000, 0xb800, 0x0000, 0x0000, 0x2800, 0xa800,
  0x0000, 0x0000, 0x4000, 0x9000, 0x0000, 0x0000, 0x5800, 0x7000,
  0x0000, 0x0000, 0x7000, 0x5800, 0x0000, 0x0000, 0x9000, 0x4000,
  0x0000, 0x0000, 0xa800, 0x2800, 0x0000, 0x0000, 0xb800, 0x1000,
  0x0000, 0x1000, 0xb800, 0x0000, 0x0000, 0x2800, 0xa800, 0x0000,
  0x0000, 0x4000, 0x9000, 0x0000, 0x0000, 0x5800, 0x7000, 0x0000,
  0x0000, 0x7000, 0x5800, 0x0000, 0x0000, 0x9000, 0x4000, 0x0000,
  0x0000, 0xa800, 0x2800, 0x0000, 0x0000, 0xb800, 0x1000, 0x0000,
  0x1000, 0xb800, 0x0000, 0x0000, 0x2800, 0xa800, 0x0000, 0x0000,
  0x4000, 0x9000, 0x0000, 0x0000, 0x5800, 0x7000, 0x0000, 0x0000,
  0x7000, 0x5800, 0x0000, 0x0000, 0x9000, 0x4000, 0x0000, 0x0000,
  0xa800, 0x2800, 0x0000, 0x0000, 0xb800, 0x1000, 0x0000, 0x0000,
  0xb800, 0x0000, 0x0000, 0x0080, 0xa800, 0x0000, 0x0000, 0x0140,
  0x9000, 0x0000, 0x0000, 0x0200, 0x7000, 0x0000, 0x0000, 0x02e0,
  0x5800, 0x0000, 0x0000, 0x03a0, 0x4000, 0x0000, 0x0000, 0x0480,
  0x2800, 0x0000, 0x0000, 0x0540, 0x1000, 0x0000, 0x0000, 0x05e0,
  0x0000, 0x0000, 0x0080, 0x05e0, 0x0000, 0x0000, 0x0140, 0x0540,
  0x0000, 0x0000, 0x0200, 0x0480, 0x0000, 0x0000, 0x02e0, 0x03a0,
  0x0000, 0x0000, 0x03a0, 0x02e0, 0x0000, 0x0000, 0x0480, 0x0200,
  0x0000, 0x0000, 0x0540, 0x0140, 0x0000, 0x0000, 0x05e0, 0x0080,
  0x0000, 0x0080, 0x05e0, 0x0000, 0x0000, 0x0140, 0x0540, 0x0000,
  0x0000, 0x0200, 0x0480, 0x0000, 0x0000, 0x02e0, 0x03a0, 0x0000,
  0x0000, 0x03a0, 0x02e0, 0x0000, 0x0000, 0x0480, 0x0200, 0x0000,
  0x0000, 0x0540, 0x0140, 0x0000, 0x0000, 0x05e0, 0x0080, 0x0000,
  0x0080, 0x05e0, 0x0000, 0x0000, 0x0140, 0x0540, 0x0000, 0x0000,
  0x0200, 0x0480, 0x0000, 0x0000, 0x02e0, 0x03a0, 0x0000, 0x0000,
  0x03a0, 0x02e0, 0x0000, 0x0000, 0x0480, 0x0200, 0x0000, 0x0000,
  0x0540, 0x0140, 0x0000, 0x0000, 0x05e0, 0x0000, 0x0000, 0x0000
};
const uint16_t PROGMEM yellowBreatherData[] = {
  0x0018,  // frame length = 24
  0x0000, 0x0000, 0x0000, 0x0000, 0x0020, 0x0020, 0x0820, 0x0020,
  0x1080, 0x1080, 0x1080, 0x1060, 0x18c0, 0x18c0, 0x18e0, 0x18c0,
  0x2940, 0x2940, 0x2940, 0x2940, 0x39c0, 0x39c0, 0x39c0, 0x39c0,
  0x5280, 0x5280, 0x5260, 0x5260, 0x6b00, 0x6b00, 0x6b00, 0x6b00,
  0x7b60, 0x7b80, 0x7b80, 0x7b80, 0x83e0, 0x83e0, 0x83e0, 0x83e0,
  0x9420, 0x9440, 0x9440, 0x9440, 0x9460, 0x9460, 0x9460, 0x9c60,
  0x9c60, 0x9460, 0x9460, 0x9460, 0x9440, 0x9440, 0x9440, 0x9420,
  0x83e0, 0x83e0, 0x83e0, 0x83e0, 0x7b60, 0x7b80, 0x7b60, 0x7b80,
  0x6b00, 0x6b00, 0x6b00, 0x6b00, 0x5280, 0x5260, 0x5280, 0x5260,
  0x39c0, 0x39c0, 0x39c0, 0x39c0, 0x2940, 0x2940, 0x2940, 0x2940,
  0x18c0, 0x18c0, 0x18c0, 0x18c0, 0x1080, 0x1080, 0x1080, 0x1080,
  0x0020, 0x0820, 0x0020, 0x0820, 0x0000, 0x0000, 0x0000, 0x0000
};
const uint16_t PROGMEM yellowChaserData[] = {
  0x0018,  // frame length = 24
  0x4a40, 0x9460, 0x39a0, 0x0000, 0x62e0, 0x9420, 0x2120, 0x0000,
  0x7360, 0x83e0, 0x10a0, 0x0840, 0x83e0, 0x7b60, 0x0840, 0x10a0,
  0x9440, 0x62e0, 0x0000, 0x2120, 0x9c60, 0x4a20, 0x0000, 0x39a0,
  0x9c60, 0x39a0, 0x0000, 0x4a40, 0x9440, 0x2120, 0x0000, 0x62e0,
  0x83e0, 0x10a0, 0x0840, 0x7360, 0x7360, 0x0820, 0x10a0, 0x83e0,
  0x62e0, 0x0000, 0x2120, 0x9420, 0x4a40, 0x0000, 0x39a0, 0x9460,
  0x39a0, 0x0000, 0x4a20, 0x9460, 0x2100, 0x0000, 0x62e0, 0x9420,
  0x10a0, 0x0820, 0x7b80, 0x83e0, 0x0820, 0x10a0, 0x83e0, 0x7360,
  0x0000, 0x2120, 0x9420, 0x62e0, 0x0000, 0x39a0, 0x9c60, 0x4a40,
  0x0000, 0x4a20, 0x9c60, 0x39a0, 0x0000, 0x62e0, 0x9420, 0x2120,
  0x0820, 0x7b60, 0x83e0, 0x10a0, 0x10a0, 0x83e0, 0x7b80, 0x0840,
  0x2100, 0x9420, 0x62e0, 0x0000, 0x39a0, 0x9460, 0x4a20, 0x0000
};

const uint8_t PROGMEM gamma5[] = {
  0x00, 0x00, 0x00, 0x00, 0x01, 0x02, 0x03, 0x05,
  0x07, 0x09, 0x0c, 0x10, 0x14, 0x18, 0x1e, 0x24,
  0x2b, 0x32, 0x3b, 0x44, 0x4e, 0x59, 0x65, 0x72,
  0x80, 0x8f, 0x9f, 0xb0, 0xc2, 0xd5, 0xe9, 0xff
};

const uint8_t PROGMEM gamma6[] = {
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01,
  0x01, 0x01, 0x02, 0x02, 0x03, 0x04, 0x04, 0x05,
  0x06, 0x07, 0x09, 0x0a, 0x0c, 0x0d, 0x0f, 0x11,
  0x13, 0x15, 0x17, 0x1a, 0x1d, 0x1f, 0x22, 0x26,
  0x29, 0x2c, 0x30, 0x34, 0x38, 0x3d, 0x41, 0x46,
  0x4b, 0x50, 0x55, 0x5b, 0x61, 0x67, 0x6d, 0x74,
  0x7a, 0x81, 0x89, 0x90, 0x98, 0xa0, 0xa8, 0xb1,
  0xba, 0xc3, 0xcc, 0xd6, 0xe0, 0xea, 0xf4, 0xff
};

const uint16_t* animations[ANIMATIONS_MAX] = {
  blueBreatherData,
  blueChaserData,
  greenBreatherData,
  greenChaserData,
  greyBreatherData,
  greyChaserData,
  magentaBreatherData,
  magentaChaserData,
  redBreatherData,
  redChaserData,
  yellowBreatherData,
  yellowChaserData,

  xmasChaserData
};

void setAnimation(const uint16_t* animation) {
  animationActive = animation + 1;
  animationLength = pgm_read_word(animation);
  animationIndex = 0;
}

bool selectAnimation(uint8_t index, int16_t loops) {
  if (index >= ANIMATIONS_MAX) {
    return false;
  }

  setAnimation(animations[index]);
  animationLoop = loops;

  return true;
}
